Dear Prof. Jean-Luc Guermond,

I am very much interested in your work about the Entropy Viscosity (EV) method 
for nonlinear hyperbolic equations. Unfortunately, I have problems in 
reproducing some results that you published. Hence, I am writing to you
in hope that you can explain to me some details about the EV method and your 
published results.

I am a young PhD student at the University of Jena, Germany. My PhD project
is concerned with high order methods for simulations in Numerical Relativity,
which I conduct together with Prof. Bernd Bruegmann. As you might know, 
encountering non-smooth and discontinuous solutions in this field of physics 
is part of the daily business. We use a discontinuous Galerkin (DG) formulation 
in conjunction with spectral elements for our numerical studies. We were 
encouraged by the very promising results presented in [1] to give the EV method 
a try within our simulations.

It is well known that shock tube test for the Euler equation, like the ones 
presented in [1], are among the most challenging ones for numerical simulations.
In my attempt to reproduce results of [1], I fail to evolve the Euler equations
for the test 2 and 3 from table 5.5. Let me briefly explain what happens:
I encounter the problem that negative pressures appear already in the very 
first time steps of the evolution. I believe that this is due to the 
velocity profile of the initial data being constant and zero. As a consequence, 
the artificial diffusion term added via the EV cannot act in the beginning 
of my simulations. Hence, it cannot counteract any potential instabilities that 
may arise in differentiation of discontinuous mass-density or energy distributions.

Based on my observations, I would claim that one needs additional tools 
(like a limiter or filter) to be able to evolve such initial data from the start. 
Nevertheless, the results published in [1] look very promising and I am very
curious about how you arrived there. Thus, my questions for you are

  Did you encounter the same problem with the shock tube tests? If so,
  how did you counteract them?

  How does your implementation perform if it encounters vanishing (or constant) 
  velocity profiles in regions of shocks?

I am also aware of the Guermond-Popov flux which were introduced in [2] and
that should cure some problems of the Navier-Stokes type regularization used in 
[1]. Unfortunately, using the Guermond-Popov flux in my program did not resolve
the issue.

It would be of great help for me if you could elaborate on the above questions
or point me to literature where I can find answers.

I am eager to receive your reply and I want to thank you for your time in 
advance!


Best regards,

Florian Atteneder


[1] ZINGAN, Valentin, et al. Implementation of the entropy viscosity method 
with the discontinuous Galerkin method. Computer Methods in Applied Mechanics 
and Engineering, 2013, 253. Jg., S. 479-490.

[2] GUERMOND, Jean-Luc; PASQUETTI, Richard; POPOV, Bojan. Entropy viscosity 
method for nonlinear conservation laws. Journal of Computational Physics, 
2011, 230. Jg., Nr. 11, S. 4248-4267.

[3] NAZAROV, Murtazo; LARCHER, Aurélien. Numerical investigation of a viscous 
regularization of the Euler equations by entropy viscosity. Computer Methods 
in Applied Mechanics and Engineering, 2017, 317. Jg., S. 128-152.
