---
title: High order methods in Numerical Relativity
date: BAMPS meeting, July 28th, 2020
author: Florian Atteneder
bibliography: ../references.bib
csl: ../styles/ieee.csl
width: 1440
height: 900
---

# 1. Project: Entropy viscosity method

. . .

![Taken from [@guercilena2017]](elh_tov.png){#id .class height=80%}

---

## How does it work? [@guermond2008; @zingan2013]

Conservation law
$$
  \partial_t u + \partial_x f(u) = 0
$$

. . .

Regularized conservation law
$$
  \partial_t u + \partial_x f(u) = \partial_x(\nu(u) \partial_x(u))
$$

. . .

Entropy viscosity
$$
\nu(u) \sim S(u) = \partial_t E(u) + \partial_x F(u) \ge 0
$$

. . .

Tuning via
$$
\nu = \nu(c_{max}, c_{e}),  \qquad c_{max}, c_{e} \in \mathbb{R}
$$

---

## Burgers' equation (gone bad)

![](burgerseq_bad.svg)

---

## Burgers' equation $f(u) = u^2$

![](burgerseq_initial.svg)

---

## Burgers' equations $f(u) = u^2$

![](burgerseq_final.svg)

---

## Advection equation $f(u) = u$

![](advectioneq_initial.svg)

---

## Advection equation $f(u) = u$

![](advectioneq_final.svg)

---

## Euler equations

![](eulereqs_initial.svg)

---

## Euler equations

![](eulereqs_final.svg)

---

## Open Questions

. . .

* How to choose $c_{max}, c_{e}$?

. . . 

* How to handle shock tube tests?

. . .

## Next steps

. . .

* Special relativistic Euler equations

. . .

* 1D TOV star

. . .

* Incorporate into BAMPS

. . .

## Thank you!

---

# Bibliography

